/* Copyright (C) 1999 Dustin Ward <Vortex@qconline.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
#include "generate.h"
#include "structs.h"

char *
myfgets (char *buf, int n, FILE * fp)
{
  char *s, *t;
  t = fgets (buf, n, fp);
  if (!t)
    return 0;
  s = buf;
  while (*s)
    {
      if (*s == 10)
	{
	  *s = 0;
	  break;
	}
      s++;
    }
  return t;
}

int
process_new (FILE * fptr, int n)
{
  fprintf (fptr, "# Automatically generated by demcd\n");
  fprintf (fptr, "#\n");
  fprintf (fptr, "# Connection Types\n");
  fprintf (fptr,
	   "# 0   --  CDDBP\n# 1   --  HTTP\n#\n");
  fprintf (fptr, "# cddbserver master.cddb.org\n");
  fprintf (fptr, "# cddbserver cddb.cddb.org\n");
  fprintf (fptr, "# cddbserver in.us.cddb.org\n");
  fprintf (fptr, "#\n");
  fprintf (fptr, "# access LOCAL\n");
  fprintf (fptr, "#\n");
  if (n != 1)
    fprintf (fptr,
	     "cddbserver freedb.freedb.org\ndefault-device /dev/cdrom\naccess REMOTE\ntype 0\n");
  fprintf (fptr, "version 2.x\n");
  fprintf (fptr, "lock off\n");
return 0;
}

int
process_config (char *buf, FILE * fp, int llock, DCD *dcd)
{
  char *val, *opt;
  int ll=0;
  int t = 0;
  register int i=0;
  char PATH[100];
  dcd->num=0;
  strcpy (PATH, getenv ("HOME"));
  strcat (PATH, "/.demcdrc");
   x=0;

   while (myfgets (buf, 256, fp))
    {
       i++;
      if(strlen(buf) > 0)
	 {
      opt = strtok (buf, "     \r\n");
      val = strtok (NULL, "\r\n");
       if (!strcasecmp (opt, "default-device"))
	{
	  strcpy (CD_DEV, val);
	}
      else if (!strcasecmp (opt, "type"))
	DEFAULTTYPE = strtol (val, NULL, 10);
      else if (!strcasecmp (opt, "access"))
	{
	  strcpy (DEFAULTACCESS, val);
	}
      else if (!strcasecmp (opt, "lock"))
	 {
	    lock=val;
	    if(!strcasecmp(val, "off"))
	      {
	      LOCKED=1;
	      }
	    ll=1;
	 }
      else if (!strcasecmp (opt, "version"))
	{
	  t = 1;
	}
      else if (!strcasecmp (opt, "cddbserver"))
	{
	   if(x==0)
	     strcpy(CDDB_DEFAULT_HOSTNAME, val);
	   addserver(val, dcd);
	   x++;
	}
      }
    }
   if(ll!=1)
     {
	  printf("config option \'lock\' not found in config, writing to config\n");       
	  lock="off";
	  printf("Writing to %s\n", PATH);
	  fclose(fp);
	  fp = fopen (PATH, "a+b");
	  fprintf(fp, "lock off");
	  fclose(fp);
	  fp = fopen (PATH, "r");
     }
  if (t != 1)
    {
      printf ("\aFound Old config file, Deleteing, Creating %s\n", PATH);
      fclose (fp);
      fp = fopen (PATH, "w");
      process_new (fp, 0);
      fclose (fp);
      fp = fopen (PATH, "r");
    }
  return 0;
}
int
writetocddb (int type, char hostname[50], char access[50])
{
  FILE *fptr;
  char PATH[100];
  char type2[40];
  char host[50];
  char acc[50];
  strcpy (acc, DEFAULTACCESS);
  strcpy (host, CDDB_DEFAULT_HOSTNAME);
  strcpy (PATH, getenv ("HOME"));
  strcat (PATH, "/.cdserverrc");
  fptr = fopen (PATH, "w");
  fprintf (fptr, "# This file is in CONSTANT write, do not touch\n");
  fprintf (fptr, "ACCESS=%s\n", acc);
  switch (type)
    {
    case CDDB_MODE_HTTP:
      strcpy (type2, "http");
       fprintf (fptr, "SERVER=%s://%s:80/~cddb/cddb.cgi, CDDB\n", type2, host);
      break;
    case CDDB_MODE_CDDBP:
      strcpy (type2, "cddbp");
      fprintf (fptr, "SERVER=%s://%s:888/, CDDB\n", type2, host);
      break;
    }

  fclose (fptr);
  system("cp ~/.cdserverrc ~/.cddbrc"); // For some older versions
return 0;
}
int
readrcconfig (int llock, DCD dcd)
{
  FILE *fptr;
  char PATH[100];
  char PATH2[100];
  char buff[256];
  char buff2[30];
  strcpy (PATH, getenv ("HOME"));
  strcpy (PATH2, getenv ("HOME"));
  strcat (PATH, "/.demcdrc");
  strcat (PATH2, "/.demrc");
  fptr = fopen (PATH2, "r");
  if (fptr)
    {
      printf ("Found OLD demcd config\n");
      printf (".. Removing\n");
      sprintf (buff2, "rm %s\n", PATH2);
      system (buff2);
      fclose (fptr);
    }
  if ((fptr = fopen (PATH, "r")) == NULL)
    {
      printf ("Creating %s\n", PATH);
      fptr = fopen (PATH, "a+b");
      process_new (fptr, 0);
      fclose (fptr);
      fptr = fopen (PATH, "r");
      process_config (buff, fptr, llock, &dcd);
      writetocddb (DEFAULTTYPE, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
      fclose (fptr);
      return 0;
    }
  process_config (buff, fptr, llock,&dcd);
  writetocddb (DEFAULTTYPE, CDDB_DEFAULT_HOSTNAME, DEFAULTACCESS);
  fclose (fptr);
  return 0;
}
